#!/usr/local/bin/perl
# download.pl
# Start downloading some file, and update the .down file with its progress

$no_acl_check++;
require './updown-lib.pl';

$down = &get_download($ARGV[0]);
$down || die "Download ID $ARGV[0] does not exist!";

# Do the download, updating the config file with progress
$down->{'pid'} = $$;
&save_download($down);
$error = &do_download($down, \&download_callback, \@paths);
$down->{'complete'} = 1;
$down->{'error'} = $error if ($error);
&save_download($down);

sub download_callback
{
if ($_[0] == 1) {
	# Started ok
	$down->{'upto'} = $progress_callback_count;
	delete($down->{'size'});
	delete($down->{'got'});
	delete($down->{'finished'});
	$lastpercent = 0;
	}
elsif ($_[0] == 2) {
	# Got size
	$down->{'size'} = $_[1];
	}
elsif ($_[0] == 3) {
	# Got some data
	$down->{'got'} = $_[1];
	if ($down->{'size'}) {
		$percent = int($down->{'got'}*100/$down->{'size'});
		return if ($percent <= $lastpercent);
		$lastpercent = $percent;
		}
	}
elsif ($_[0] == 4) {
	# All done
	$down->{'finished'} = 1;
	$down->{'total'} += $down->{'got'};
	}
elsif ($_[0] == 5) {
	# Redirecting to new URL
	}
&save_download($down);
}

